function NSLog(msg) {
	if(window.Context) {
		window.Context.debugLog_(msg);
	} else {
		window.console.log(msg);
	}
}

function DJLog(msg) {
	if(window.Context) {
		window.Context.debugLog_(msg);
	} else {
		window.console.log(msg);
	}
}

/*
 	Context Globals
*/
//The length from edges of scroll area that will trigger the scrolling on dragand drop
ScrollAreaDragEdgeLength = 10;

/*
	Supports various css hacks for our contextui for some ThinkingCode mac products
*/

var UI = {};
UI.selectTools = {};
UI.selectTools.updateHtmlSelect = function(element) {
	$(element).each(function() {
		var selectedText = $(this).find('option:selected').text();
		var selectedValue = $(this).find('option:selected').attr('value');
		
		var selectedBind = $(this).find('option:selected').attr('bnd');
		var selectedBindKey = $(this).find('option:selected').attr('bkey');
		var selectedBindValue = $(this).find('option:selected').attr('bto');
		
		var selectTextEl = $(this).closest('.html-select').find('span.title');
		
		//Handle no selection
		if(selectedText) {
			selectTextEl.text(selectedText);
			if(selectedBind) {
				selectTextEl.attr('bnd', selectedBind);
				selectTextEl.attr('bkey', selectedBindKey);
				selectTextEl.attr('bto', selectedBindValue);
			}
		} else {
			selectTextEl.html('<span class="placeholder">'+selectTextEl.attr('placeholder')+'</span>');
			selectTextEl.attr('bnd', '');
		}
		
		//NSLog('updateing selector popup value:'+selectedValue);
	});
}

$(function() {

//Various context notifications
$(document).bind('mousewheel', function() {
	window.Context.scrollEventNotification();
});

//<div class='html-select'><select>...</select></div> custom popup support
UI.selectTools.updateHtmlSelect($('div.html-select > select'));

$('div.html-select > select').die('change.htmlselect').live('change.htmlselect', function(e) {
	UI.selectTools.updateHtmlSelect(this);
});

UI.selectTools.setHTMLSelectedValue = function(id, value) {
	$(id).find('option:selected').removeAttr('selected');
	$(id).find("option[value='"+value+"']").attr('selected', 'selected');
	UI.selectTools.updateHtmlSelect($(id).find('select'));
}

/*
	-------------------------------------------------------------------------------------------
	Psudo fields and forms class .form -> .opt .button .submit .label

	<div class='ph' placeholder='A Placeholder String'></div>

	should have a attribute placeholder='Value for placeholder'
*/

//simple hack for if the user clicks on the placeholder text not the backing <div class='opt'>
$('.ph').each(function() {
	var placeholder = $(this).attr('placeholder');
	if(placeholder && placeholder.length > 0) {
		$(this).empty(); //WebKit adds a <br> sometimes that causes prblems with the placeholder
		$(this).append("<span class='placeholder' style='-webkit-user-modify: read-only'>"+placeholder+"</span>");
	}
});

var infocus;
$('.ph span.placeholder').live('mousedown', function(e) {
	e.stopPropagation();
	
	var opt = $(this).closest('.ph');
	$(this).remove();
	
	if(infocus)
		infocus.blur();
	
	opt.focus();
	opt.trigger('click');

	return false;
});

$('.ph').live('focus', function() {
	var placeholder = $(this).attr('placeholder');
	if(placeholder && placeholder.length > 0) {
		$(this).find('span.placeholder').remove();
		
	}
	infocus = this;
	$(this).addClass('focused');
}).live('blur', function() {
	var placeholder = $(this).attr('placeholder');

	if(placeholder && placeholder.length > 0) {
		var value = $(this).text();
		if(!value || value.length < 1) {
			$(this).empty(); //WebKit adds a <br> sometimes that causes prblems with the placeholder
			$(this).append("<span class='placeholder' style='-webkit-user-modify: read-only'>"+placeholder+"</span>");
		}
	}
	$(this).removeClass('focused');
});

//Single row fields (ie trap 'enter' events)
$('.opt.nowrap').live('keydown', function(e) {
	if(e.keyCode == 13) {
		return false;
	}
});

//Basic form functionality setup
$('.form').each(function() {
	if($(this).find("div.button[key='enter']").length>0) {
		var that = this;
		$(this).find('.opt').keydown( function(e) {
			if(e.keyCode == 13) {
				$(that).find("div.button[key='enter']").click();
				return false;
			}
		} );
	}
});

});


/*
	Scroll View Divs
	-----------------------------
*/
$('.scroll-view').live('dragover', function(e) {
	var px = (e.clientX-$(this).offset().left);
	var py = (e.clientY-$(this).offset().top);
	var sh = $(this).height();
	var sw = $(this).width();
	//NSLog('dragged x:+'+px+'/'+$(this).width()+' y:'+py+'/'+$(this).height());
	
	
	//This allows for the speed to steadaly increase based on amount in
	
	if(py < ScrollAreaDragEdgeLength-3) {			//up
		$(this).scrollTop($(this).scrollTop()-16);
	} else if(py > sh-ScrollAreaDragEdgeLength && py < (sh-ScrollAreaDragEdgeLength)+5) {	//down
		$(this).scrollTop($(this).scrollTop()+3);
	} else if(py < ScrollAreaDragEdgeLength) {			//up
		$(this).scrollTop($(this).scrollTop()-3);
	} else if(py > sh-ScrollAreaDragEdgeLength) {	//down
		$(this).scrollTop($(this).scrollTop()+16);
	}
});


/*
	Dejumble Context Syntext parsers for titles and notes
	---------------------------------------------
*/

// {link-string} or {link-string}[Title String]
function ProcessDejumbleLinks(string) {
	//Structured title link[Title]
	string = string.replace(/(\s|^)(((([a-z]{2,10}):(([A-Za-z0-9%$_.+!*(),;/?:@&~=-])|%[A-Fa-f0-9]{2}){2,}(#([a-zA-Z0-9][a-zA-Z0-9$_.+!*(),;/?:@&~=%-]*))?([A-Za-z0-9$_+!*();/?:~-]))))(\[([a-zA-Z0-9 ]+)\])/g, function(str) {
		return str.replace(/([\w.\:\/]+)(\[([a-zA-Z0-9 ]+)\])/g, "<a href='$1'>$3</a>")
	});
		
	string = string.replace(/(\s|^)([A-Za-z0-9%$_.+]+(\.(com|org|ca|net|us|co.uk|me)))(\[([a-zA-Z0-9 ]+)\])/g, function(str) {
		return str.replace(/([\w.\:\/]+)(\[([a-zA-Z0-9 ]+)\])/g, "<a href='http://$1'>$3</a>")
	});
	
	//Basic
	string = string.replace(/(\s|^)(((([a-z]{2,10}):(([A-Za-z0-9%$_.+!*(),;/?:@&~=-])|%[A-Fa-f0-9]{2}){2,}(#([a-zA-Z0-9][a-zA-Z0-9$_.+!*(),;/?:@&~=%-]*))?([A-Za-z0-9$_+!*();/?:~-]))))/g, function(str) {
		str = str.replace(/\s/g, '');
		return " <a href='"+str+"'>"+str+"</a>";
	});
	
	string = string.replace(/(\s|^)([A-Za-z0-9%$_.+]+(\.(com|org|ca|net|us|co.uk|me)))/g, function(str) {
		str = str.replace(/\s/g, '');
		return " <a href='http://"+str+"'>"+str+"</a>";
	});
		
	return string;
}

/*
	Wiki Text
*/
// Does the wiki notes markup processing the given string, see https://thinkingcode.codebasehq.com/dejumblemac/wiki/Notes_wiki_markup_syntex
function DNotesProcessHTMString(string) {

	//Tasks
	//string = string.replace(/\>- ([a-zA-Z0-9\.,:;\+-_@\?\!#\$%\* ]+)\<\//g, "><div class='subtask'><span class='wiki-check'></span>$1</div></");
	//string = string.replace(/^- ([a-zA-Z0-9\.,:;\+-_@\?\!#\$%\* ]+)\</g, "<div class='subtask'><span class='wiki-check'></span>$1</div><");
	
	//Remove all tags except the allowed '<i><b><strike><div><br>'
	//string=string.replace(/<\s*([a-oq-z]|p\w|\!)[^>]*>|<\s*\/\s*([a-oq-z]|p\w)[^>]*>/gi, "");
	string=string.replace(/<\s*p[^>]+>/gi, "<p>");
	string=string.replace(/<(font|span)[^>]+>|<(font|span)>|\<\/(font|span)\>/g, "");
	
	return string;
}

$('.subtask > .wiki-check').live('click', function(e) {
	e.stopPropagation();
	var subtask = $(this).closest('.subtask');
	if(subtask.hasClass('checked')) {
		subtask.removeClass('checked');
	} else {
		subtask.addClass('checked');
	}
	return false;
});

/*
	----------------------------
	Application Tabs
	----------------------------
*/
function JSCKSelectTab(tab) {
	//NSLog('css display:['+$('#'+tab).css('display')+']');
	if($('#'+tab).css('display') == 'none') {
		$('.ApplicationTab').hide()
		$('#'+tab).show();
	}
	
	$(document).trigger('ApplicationTabChanged');
}

/*
	Fix for cocoa core data objects and accessors
	Cocoa Model Objects are wrapped as a basic js object.
*/
function makeWrappedObject(obj) {
	
	var wrapper = {
		object:obj,
		call:0,
		valueForKey:function(key) {
			if(typeof this.object.valueForKey != 'function') {
				NSLog("***** FIXME: Object passed to CDObject not a NSManagedObject, try again "+this.call+" "+key+" ******");
				return "";
			}
			this.call++;
			return this.object.valueForKey(key);
		},
		valueForKeyPath:function(key) {
			return this.object.valueForKeyPath(key);
		},
		setValueForKey:function(value, key) {
			this.object.setValueForKey(value, key);
		}
	}
	
	return wrapper;
}

function CDObject(object) {
	return makeWrappedObject(object);
}

function CDArray(array) {
	var newArray = [];
	for(i in array) {
		newArray.push(makeWrappedObject(array[i]));
	}
	return newArray;
}