/*********************************** TaskCreateView ***********************************/
/*************************************************************************************/

/*
	Cocoa controller class 'TaskCreateController'
	div#add-task-area
*/

//Loads the given array of projects
UpdateSelectableProjectList = function(projects) {
	var select = $('div.project-selector select').empty();
	
	/* We manually add the Inbox row, with the projects as a seperate list */
	select.append('<option value="__inbox">Inbox</option>');
	//select.append('<option value="blnk_1" disabled>Projects ---</option>');
	var i, c = projects.length;
	for(i=0; i<c; i=i+1) {	
		var project = projects[i];
		if(project.valueForKey("state") != "filed") {
			var projid = project.valueForKey('uid')
			select.append('<option value="'+projid+'" bnd="Project/'+projid+'" bkey="title" bto="html">'+project.valueForKey('title')+'</option>');
		}
	}
	
	//Add an empty if no projects (first run)
	if(projects.length<0) {
		select.append('<option value="none">No projects...</option>');
	}
	
	//Select the first item
	UI.selectTools.updateHtmlSelect(select);
}

SetProjectSelectedForProjectList = function(uid) {
	UI.selectTools.setHTMLSelectedValue('#add-task-area #project-selector', uid);
}

function showAddTaskArea() {
	$('#ApplicationTabTasks').upperArea();
	$('div#add-task-area').find('#title').focus();
}

function hideAddTaskArea() {
	$('#ApplicationTabTasks').upperArea(false);
}

var DateToolTipFadeTimeout;
function showDateToolTipWithString(str) {
	var dateToolTip = $('div#add-task-area div#date-row.row-opt div.tooltip');
	
	if(!str) {
		dateToolTip.fadeOut('fast');
		return;
	}
	
	dateToolTip.text(str).fadeIn('fast');
	
	var that = dateToolTip;
	
	if(DateToolTipFadeTimeout) {
		window.clearTimeout(DateToolTipFadeTimeout);
	}
	
	if(str != '??') {
		dateToolTip.removeClass('error');
		DateToolTipFadeTimeout = window.setTimeout(function() {
			if(!that.is(':hidden') && that.text() != '??') {
				that.fadeOut('slow');
			}
		}, 2000);
	} else {
		dateToolTip.addClass('error');
	}
}

//On ready
$(function() {	
	
	//'Add' button action
	$('div#add-task-area div#add-button').click(function() {
		var addTaskArea = $(this).closest('div#add-task-area');
		var title = addTaskArea.find('#title.opt').text();
		var date = addTaskArea.find('#date.opt').attr('date');
		var proj = addTaskArea.find('#project-selector select option:selected').attr('value');
		
		if(!date) {
			date = '';
		}
				
		if(title != 'Title') {	
			var success = TaskCreateController.createTaskWithTitle_date_project_(title, date, proj);
			if(success) {
				addTaskArea.find('#title.opt').text('').blur();
				addTaskArea.find('#date.opt').text('').blur();
			}
		} else {
			Context.beep();
		}
	});
	
	//Date placeholder support and parsing to a cocoa format
	$('div#add-task-area div#date.opt').keyup(function() {
		var dateStr = $(this).text();
	
		if(dateStr && dateStr.length > 0) {
			var date = Date.parse(dateStr);
			if(date) {
				$(this).attr('date', date.getTime()); //parseable with NSDate dateWithTimeIntervalSince1970
				showDateToolTipWithString(date.toString('MMM d'));
			} else {
				NSLog('will remove the date');
				$(this).removeAttr('date');
				showDateToolTipWithString('??');
			}
		} else {
			$(this).removeAttr('date');
			showDateToolTipWithString();
		}
	});
	
	$('div#project-create-window-open').click(function(e) {
		e.stopPropagation();
		TaskCreateController.showProjectCreateAtTop_left_($(document).height()-$(this).offset().top-($(this).height()/2), $(this).offset().left+36);
		return false;
	});
	
	//simple menu test for popup context menus via NSMenu
	$('div#project-selector').mousedown(function() {
		//NSLog('mouse down for project selector');
		$('div#add-task-area #title.opt').blur();
	});
	
	//Fixes for safari 5 and blurring backing hidden seletor
	$('div#add-task-area #project-selector select').change(function() {
		$(this).blur();
	});
});