/*
	Basic actions for the list view.
	Each jquery binding calls the applicable public method
	
	Note that these call the TaskController methods via cocoa calls.
	
	TODO: This needs to be wrapped up into frothjs classes based on various widgets.
	
	All content editable fields that act as TextFields send their change events on 'blur' or
	enter. unless they are considered continues, in that case they send event on keypress
*/

var Dejumble = {};

//TODO call the TaskListController controller if we should show headers and store variable here.
var ListShowsProjectHeaders = true;

function GetTask(guid) {
	/*if(!ProjectsController || !ProjectsController.tasks)
		return null;
	
	var i, c = ProjectsController.tasks.length;
	for(i=0; i<c; i=i+1) {
		if(ProjectsController.tasks[i].valueForKey('uid') == guid) {
			return ProjectsController.tasks[i];
		}
	}*/
	return TaskListController.taskWithUID_(guid);
}

function GetTaskProxy(guid) {
	return TaskListController.taskProxyWithUID_(guid);
}

function GetSelectedTask() {
	var uid = $('div.task-row.selected').attr('id');
	return GetTask(uid);
}

//My return a Dejumble username, or system username if no dejumble username.
function GetMyUsername() {
	return TaskListController.getMyUsername();
}

var EditingTask = false;
$(document).ready(function() {
	
	/*
		Headers
		Depreciated...
	*/
	$("div.group div.header").die('click').live('click', function(){
		var groupEl = $(this).closest("div.group");
		if(groupEl.hasClass('closed')) {			
			openProjectGroup(groupEl.attr('id'));
			TaskListController.openProjectGroup_(groupEl.attr('id'));
		} else {
			TaskListController.closeProjectGroup_(groupEl.attr('id'));
			closeProjectGroup(groupEl.attr('id'));
		}
	});
	
	/*
		Updating completed
		
		TODO:Evaluate
	*/
	$(".checkmark").die('click').live('click', function(e) {
		e.stopPropagation();
		
		var rowEl = $(this).closest(".guid");
		var guid = rowEl.attr('id');
		toggleTaskCompletion(guid);
		
		try {
			if(!rowEl.hasClass('complete')) {
				GetTask(guid).setValueForKey(false, 'completed');
			} else {
				GetTask(guid).setValueForKey(true, 'completed');
			}
			TaskListController.taskDidToggleCompletion_(guid);
		} catch(e) {
			window.alert(e.toString());
		}
		
		//Not really needed..
		TaskListController.toggleTask_(guid);
		
		return false;
	});
	
	/* 
		Label Filter Auto Select
	*/
	$(".label[id]").die('click').live('click', function(e) {
		e.stopPropagation();
		if($(this).hasClass('selected')) {
			TaskListController.selectLabel_('');
		} else {
			TaskListController.selectLabel_("#"+$(this).attr('id'));
		}
		return false;
	});
	
	/*
		Priority Auto Filter Select
	*/
	$(".priority").die('click').live('click', function(e) {
		e.stopPropagation();
		if($(this).hasClass('selected')) {
			TaskListController.selectPriority_('');
		} else {
			TaskListController.selectPriority_($(this).attr('id').replace('pr', '!'));
		}
		return false;
	});
	
	/*
		Date Auto Filter Select (ON:Date String)
	*/
	$("div.task-row span.date").die('click').live('click', function(e) {
		e.stopPropagation();
		TaskListController.selectDateFilter_($(this).attr('date'));
		return false;
	});
	
	/* 
		Open task editor
	*/
	/*$("div.task-row").die('dblclick').live('dblclick', function(e) {
		//TaskListController.selectTask_($(this).attr('id'));
		EditingTask = true;
		editTask($(this).attr('id'));
	});*/
	
	
	/* 
		Select/Edit a row
	*/
	var clickCount = {};
	var timout;
	$("div.task-row").die('click').live('click', function() {

		var guid = $(this).attr('id');
		if(!clickCount[guid])
			clickCount[guid] = 0;
		clickCount[guid]++;
		
		if(window.TaskListController) {
			TaskListController.selectTask_(guid);
		}
		
		if(clickCount[guid]>1) {
			editTask(guid);
		}
			
		timout = window.setTimeout(function() {
			if(clickCount[guid]<2 && clickCount[guid]>0) {
				endEditTask(guid);
			}
			clickCount[guid] = 0;
		}, 500);
	});
	
	// !Key Shortcuts
	/*
		=============================
		Selected Row Key Shortcuts
		=============================
	*/
	/*$(document).keypress(function(e) {
		//delete or del
		if($(':focus').length < 1 && GetSelectedTask() && (e.keyCode == 8 || e.keyCode == 63272)) { //Delete selected task
			
			//Only works if nothing else is not in focus, and the selected task is not in a collapsed group.
			TaskListController.deleteSelectedTask();
			
			return false;
		}
		//NSLog('keycode:'+e.keyCode);	
		//esc (end editing)
		//if(e.keyCode ==)
	});*/
	
	// !Drag and Drop
	/*
		=============================
		Drag and Drop (Within Window)
		=============================
	*/
	/*
		Visually Represent the Drag
	*/
	var dragSpacer = 10;
	
	var dragItem;
	var dragOverRow;
	var dragLocation;
	var dragInHeader;
	//Start drag operation
	$(".task-row").live('dragstart', function(event) {
		dragItem = $(this);
		dragOverRow = $(this);
		var oy = event.originalEvent.offsetY;
		var eh = $(this).height();
		
		if(oy < eh/2.0) {	//Start from top
			dragOverRow.css({ marginTop: dragSpacer });//, { queue:false }, 50);
			dragLocation = 'top';
		} else {			//Start from bottom
			dragOverRow.css({ marginBottom: dragSpacer-1 });//, { queue:false }, 50);
			dragLocation = 'bottom';
		}
		
		//Set the data info for task
		/*
			dejumble/task-object-uid -> task.uid
			text/plain -> task title
		*/
		event.originalEvent.dataTransfer.effectAllowed = 'moveCopy';
		event.originalEvent.dataTransfer.setData('dejumble/task-object-uid', dragItem.attr('id'));
		event.originalEvent.dataTransfer.setData('text/plain', GetTask(dragItem.attr('id')).valueForKey('title'));
	});
	
	
	$(".task-row").live('dragenter', function(event) {
		if(!dragOverRow || dragOverRow.attr('id') != this.id) { 
			//Remove margins
			if(dragOverRow) {
				removeDragOffsets(dragOverRow)
			}
			
			var oy = event.originalEvent.offsetY;
			var h = $(this).height();
			dragOverRow = $(this);	
			if(h/2.0 > oy) {
				dragOverRow.css({ marginTop: dragSpacer,  marginBottom: "-1px" });//, { queue:false }, 50);
				dragLocation = 'top';
			} else {
				dragOverRow.css({ marginBottom: dragSpacer-1 });//, { queue:false }, 50);
				dragLocation = 'bottom';
			}
		}
	});
	
	$(".task-row").live('dragover', function(event) {
		if(dragOverRow.attr('id') == this.id) {
			var oy = event.originalEvent.offsetY;
			var h = $(this).height();
			if(dragLocation == 'top' && oy > h/2.0) {
				//Move spacer to bottom
				dragOverRow.css({ marginTop: '0px', marginBottom: dragSpacer-1 });//, { queue:false }, 50);
				dragLocation = 'bottom';
			} else if(dragLocation == 'bottom' && oy < h/2.0) {
				//Move spacer to top
				dragOverRow.css({ marginTop: dragSpacer, marginBottom: "-1px" });//, { queue:false }, 50);
				dragLocation = 'top';
			}
		}
	});
	
	//End drag operation
	$(".task-row").live('dragend', function(event) {
		removeDragOffsets(dragOverRow);
		
		var dragItemId = dragItem.attr('id');
		if(dragLocation == 'top' && dragOverRow) {
			if(TaskListController.dragTaskItem_to_position_(dragItemId, dragOverRow.attr('id'), 'above')) {
				dragOverRow.before(dragItem);
			}
		} else if(dragLocation == 'bottom' && dragOverRow) {
			if(TaskListController.dragTaskItem_to_position_(dragItemId, dragOverRow.attr('id'), 'below')) {
				dragOverRow.after(dragItem);
			}
		} else if(dragLocation == 'in') {
			NSLog('drag to:'+dragInHeader.closest('.group').attr('id'));
			TaskListController.moveTaskItem_toProjectItem_(dragItemId, dragInHeader.closest('.group').attr('id'));
		}
		
		//Cleanup
		delete dragLocation;
		delete dragInHeader;
		delete dragItem;
		delete dragOverRow;
	});
	
	$("div#list-view").live('dragover', function(e) {
		e.preventDefault();
	});
	
	$("div#list-view").live('drop', function(e) {
		NSLog('handle drop');
		window.console.log(e.originalEvent.dataTransfer);
		//window.console.log(e.originalEvent.dataTransfer.types);
		//window.console.log(e.originalEvent.dataTransfer.getData('dejumble/task-object-uid'));
		//window.console.log(e.originalEvent.dataTransfer.getData('public.url'));
		
		//Task data -> 'dejumble/task-object-uid'
		
		e.originalEvent.dataTransfer.dropEffect = 'none';
		for(var i in e.originalEvent.dataTransfer.types) {
			if(e.originalEvent.dataTransfer.types[i] == 'dejumble/task-object-uid') {
				e.originalEvent.dataTransfer.dropEffect = 'move';
				break;
			}
		}
	});
	
	/*$(".task-row").bind('dragenter', function(event) {
	});
	
	$(".task-row").bind('dragleave', function(event) {
		$(this).removeClass('drag-over');
	});
	*/
	
	/*
		Make Group Headers dropable for adding to group.
	*/
	$("div.group div.header h1").live('dragenter', function(event) {
		$(this).addClass('drag-over');
		removeDragOffsets(dragOverRow);
		dragLocation = 'in';
		dragInHeader = $(this); 
	});
	
	$("div.group div.header h1").live('dragleave', function(event) {
		$(this).removeClass('drag-over');
		removeDragOffsets(dragOverRow);
	});
	
	/*
		========================
		Editor Options
		========================
	*/
	$("#optdate").die('click').live('click', function(e) {
		TaskListController.showDatePickerForTaskIdentifier_top_left_height_width_($(this).closest('.guid').attr('id'), $(this).offset().top-window.pageYOffset, $(this).offset().left, $(this).height(), $(this).width());
	});
	
	/*$("#optdate-label").die('click').live('click', function(e) {
		var datef = $(this).next('#optdate');
		TaskListController.showDatePickerForTaskIdentifier_top_left_height_width_(datef.closest('.guid').attr('id'), datef.offset().top-window.pageYOffset, datef.offset().left, datef.height(), datef.width());
		e.stopPropagation();
		return false;
	});*/
	
	/*
		=======================
		Application Tab Changes
		=======================
	*/
	$(document).bind('ApplicationTabChanged', function(e) {
		endEditTask();
	});
				  
	//For testing in safari
	if(!window.TaskListController)
		LayoutList(["one"])
		
		
	//Click on open area to close task editor.
	
});

function removeDragOffsets(row) {
	row.css({ marginTop:"0px", marginBottom:"-1px" }, { queue:false }, 50);
}

/*
	Return a cloned template ready to poptilate
*/
var GroupTemplateObject;
function GroupDivFromTemplate() {
	if(!GroupTemplateObject) {
		GroupTemplateObject = document.getElementById('group_template');
	}
	return $(GroupTemplateObject)
	.clone()
	.removeAttr('id');
}

var  RowTemplateObject;
function RowDivFromTemplate() {
	if(!RowTemplateObject) {
		RowTemplateObject = document.getElementById('task_template');
	}
	
	return $(RowTemplateObject)
	.clone()
	.removeAttr('id')
	.removeClass('task-row-temp')
	.addClass('task-row');
}

/*
	==============================================
	Private Functions
	==============================================
*/

/*
	Cleans all task related attributes and classes from a task row, in preperation for updating with 
	task changes.
*/
function cleanRow(row) {
	//Clean up row attribute classes
	row.removeClass('overdue');
	row.removeClass('anytime');
	row.removeClass('today');
	row.removeClass('complete');
	row.removeClass('filed');
	
	row.removeClass('pending');
	row.removeClass('unread');
}

/*	Adds or update ui row for given task (internal update method)
	Supported date added classes to row (anytime, today, overdue) */
function updateTaskRow_(task, row, showsProjectTitle) {
	cleanRow(row);
	
	taskId =  task.valueForKey('uid');
	
	row.attr('id', taskId);
	var titleEl = row.find('.title');
	
	var rTitle = task.valueForKey('title');
	if(rTitle) {
		titleEl.html(parsedTaskTitle(task.valueForKey('title'))).attr('bnd', 'Task/'+taskId);
	} else {
		//The row is considered 'pending' for the purpose of creating a new one.
		row.attr('state', 'pending');
	}
	
	//Set the project title (Only shown under the Search tab)
	var pTitleEl = row.find('.project-title');
	
	var shareState = task.valueForKey('shareState');
	row.attr('shareState', shareState);
	if(shareState < 10) {
		row.addClass('unread');
	} else if(shareState < 20) {
		row.addClass('pending');
	}
	
	if(task.valueForKey('isIncomming')) {
		pTitleEl.html("<img class='from-img' src='shared_cell_image_to_me.png'/>"+task.valueForKey('ownerName'));
	} else {
		if(showsProjectTitle && showsProjectTitle == 1) {
			pTitleEl.text(task.valueForKeyPath('project.title'));
		} else if(showsProjectTitle && showsProjectTitle == 0) {
			pTitleEl.text('');
		}
		
		//Check if its mine to show the share indicator
		if(!task.valueForKey('mine')) {
			titleEl.append("<span class='not-mine'><img src='shared_cell_image_to_me.png' title='"+
								task.valueForKey('ownerName')+" is sharing this task with you." +
							"'/></span>");
		} else if(task.valueForKey('shared')) {
			titleEl.append("<span class='not-mine'><img src='shared_cell_image_to_me.png' title='You are the owner of this task.'/></span>");
		} else {
			titleEl.find("span.not-mine").remove();
		}
	
	}
	
	//Check if theirs notes to show the notes indicator
	if(task.valueForKey('hasNotes')) {
		titleEl.append("<span class='note'><img src='note_icon.png' title='Indicates that this task has notes.' onclick='TaskListController.openTaskInExternalWindow_($(this).guid())'/></span>");
	} else {
		titleEl.find("span.note").remove();
	}
	
	//Check if theirs subtasks to show in the subtask indicator
	var subtaskCount = task.valueForKey('countOfSubtasks');
	if(subtaskCount > 0) {
		titleEl.append("<span class='subtask-count'>✔" + subtaskCount +"</span>");
	} else {
		titleEl.find('span.subtask-count').remove();
	}	
		
	//Silently fails if not editing this task.
	var editRow = $('.task-edit[id="'+taskId+'"]');
	
	var dueDate = task.valueForKey('dueDate');
	var editorDateEl = editRow.find('#optdate');
	
	if(DWiki.Editor && !DWiki.Editor.editing && DWiki.Editor.ref == taskId) {
		DWiki.Editor.setWikiText(task.notes);
	}
	
	if(dueDate) {
		var jsdate = Date.parse(dueDate.description());
		var dateEl = row.find('.date');
		var isAllDayToday;
		
		if(jsdate.isToday()) {
			//Check if its has a time for today, or its due anyime today
			if(jsdate.getHours() > 0 && jsdate.getMinutes() > 0) {
				dateEl.text(jsdate.toString('h:mm tt'));
			} else {
				dateEl.text('Today');
				isAllDayToday = true;
			}
			
			row.addClass('today');
		} else {
			dateEl.text(jsdate.toString('MMM d'));
		}
		dateEl.attr('date', jsdate.getTime());
		
		if(jsdate.isBefore(new Date()) && !isAllDayToday) {
			row.addClass('overdue');
		}
	} else {		//Anytime
		row.addClass('anytime').find('.date').text('Anytime');
	}
	
	if(task.valueForKey('completed') == true) {
		row.find('input.checkmark').attr('checked', 'checked');
		row.addClass('complete');
	} else {
		row.find('input.checkmark').removeAttr('checked');
		row.removeClass('complete');
	}
	
	if(task.valueForKey('status') && task.valueForKey('status') == 'Filed') {
		row.addClass('filed');
	}
}

/*
	==============================================
	Callable from cocoa in TaskListViewController
	==============================================
	These typically do not call cocoa class methods becouse they are
	callable from them.
*/
function openProjectGroup(guid) {
	var group = document.getElementById(guid);
	$(group)
	.removeClass('closed')
	.find('.rows')
	.slideDown('fast');
}

function closeProjectGroup(guid) {
	var group = document.getElementById(guid);
	$(group)
	.addClass('closed')
	.find('.rows')
	.slideUp(400, function() { endEditTask(); });
	
	//remove selected task if its in this project group
	if(GetSelectedTask().valueForKey('project').valueForKey('uid') == guid) {
		TaskListController.selectTask_('');
	}
}

function toggleTaskCompletion(guid) {
	var row = $('.guid[id='+guid+']');
	if($(row).hasClass('complete')) {
		$(row).removeClass('complete');
	} else {
		$(row).addClass('complete');
	}
}

function editTask(guid) {	
	var task = GetTask(guid);
	
	var needsConnectionConfirmed = false;
	if(task.valueForKey('fromPendingConnection')) {
		NSLog("Open task in read-only view");
		needsConnectionConfirmed = true;
	}
	
	var taskRow = $("div.task-row#"+guid);
	
	endEditTask();
	
	var editArea = $('.task-edit-temp')
	.clone()
	.removeClass('task-edit-temp')
	.addClass('task-edit');
	
	//Classes copied from backing display row.
	if(taskRow.hasClass('complete')) {
		editArea.addClass('complete');
	}
	if(taskRow.hasClass('today')) {
		editArea.addClass('today');
	}
	if(taskRow.hasClass('overdue')) {
		editArea.addClass('overdue');
	}
	if(taskRow.hasClass('anytime')) {
		editArea.addClass('anytime');
	}
	
	$("div.task-row").show();	//Show all
	taskRow
	.after(editArea)
	.hide();
	
	editArea
	.show()
	.attr('id', guid);
	
	//Edit area notes bar options
	editArea.find('#open-notes-extern').click(function(e) {
		
		TaskListController.openTaskInExternalWindow_(guid);
		
		e.stopPropagation();
		e.preventDefault();
		return false;
	});
	
	//Show in ScrollView Better
	/* TODO this has some bugs */
	//insure that the dom is fully visible if possible, nudging up or down as needed.
	var scrollView = editArea.closest('.scroll-view');
	//NSLog('offset-top:'+editArea.offset().top+" hieght:"+editArea.height()); //editArea.closest('.scroll-view');
	//NSLog('scrollview-top:'+scrollView.offset().top+" hiegth:"+scrollView.height());
	
	if(editArea.offset().top+editArea.height() > scrollView.height()-5) {	//Scroll From Below
		editArea.closest('.scroll-view').animate({scrollTop:(scrollView.height()-editArea.height())+scrollView.scrollTop()}, 500);
	}
	
	//Title field
	var titleField = editArea.find('div.title');
	
	if(task.valueForKey('title')) {
		titleField.html(task.valueForKey('title'));
	} else {
		titleField.html("");
		titleField.focus();
	}
	
	titleField.attr('bnd', 'Task/'+guid)
	.keydown(function(e) {
		if(e.keyCode == 13) {
			$(this).blur();
			endEditTask();
			e.preventDefault();
		}
	})
	.blur(function(e) {
		/*
			Check if it's a new task, if so, we set the task's title locally, and post
			a new task created notification
		*/
		var ntitle = $(this).text();
		var tstate = taskRow.attr('state');
		if(ntitle && ntitle.length > 2) {
			if(tstate && tstate == 'pending') {
				taskRow.attr('state', 'normal');
				var nt = GetTask(guid);
				nt.setValueForKey(ntitle, 'title');
				TaskListController.postNewTaskNotification_(nt);
				NSLog('created a new task');
			} else {
				taskRow.attr('state', 'normal');
				TaskListController.taskDidEndTitleEditing_title_(guid, ntitle);
			}
		}
	});
	
	//Notes area
	
	var notesArea = editArea.find('.edit-notes-area');
	DWiki.WikiFromContentEditable(notesArea[0], task.valueForKey('notes'), function(notes, ref) {
		
		//GetTask(ref).setValueForKey(notes, 'notes');
		TaskListController.taskDidEndNoteEditing_notes_(ref, notes);
		
	}, task.valueForKey('uid'));
	
			
	/*if(task.valueForKey('notes')) {
		notesArea.empty().html(DWikiHTMLFromWiki(task.valueForKey('notes')));
		lastText = task.valueForKey('notes');
	}
	notesArea.bind('blur', function() {
		
		if($(this).text() != $(this).attr('placeholder')) {
			GetTask(guid).setValueForKey(DWikiWikiFromHTML($(this).html()), 'notes');
			
			//save the wiki text to context
			lastText = DWikiWikiFromHTML($(this).html());
			
			//update html
			$(this).html(DWikiHTMLFromWiki(lastText));	
			
		} else {
			GetTask(guid).setValueForKey(null, 'notes');
		}
	}).bind('focus', function() {
		$(this).empty().html(DWikiHTMLFromWiki(DWikiWikiFromHTML(task.valueForKey('notes')));
	});*/
	
	//Date
	var duedateArea = editArea.find('#optdate');
	var duedate = task.valueForKey('dueDate');
	if(duedate) {
		var jsdate = Date.parse(duedate.description());
		
		if(jsdate.isToday()) {
			//Check if its has a time for today, or its due anyime today
			if(jsdate.getHours() > 0 && jsdate.getMinutes() > 0) {
				duedateArea.empty().text(jsdate.toString('h:mm tt'));
			} else {
				duedateArea.empty().text('Today');
			}
		} else {
			duedateArea.empty().text(jsdate.toString('MMM dd')+ ' at '+jsdate.toString('h:mm tt'));
		}
	}
	//Auto format dates
	
	var changed = false;
	duedateArea.keyup(function(){
		var dateStr = $(this).text();
	
		if(dateStr && dateStr.length > 0) {
			var date = Date.parse(dateStr);
			if(date) {
				TaskListController.setDatePickerDateString_taskIdenifiter_( date.getTime(), $(this).closest('.guid').attr('id'));
			} else {
				//Should all question marks to date.
				//NSLog('will remove the date');
				//$(this).removeAttr('date');
				//showDateToolTipWithString('??');
			}
		} else {
			NSLog("Should remove date, and make anytime");
			TaskListController.setDatePickerDateString_taskIdenifiter_(null, $(this).closest('.guid').attr('id'));
		}
		changed = true;
	});
	
	//Fixes issue where the title field is not receiving the blur message when the date field is focused
	duedateArea.focus(function() {
		titleField.blur();
	});
	
	//Basic editor defualts
	editArea.find('.task-options div#proj-picker > span.title').html(task.valueForKey('project').valueForKey('title'));
	editArea.find('.task-options div#proj-picker > select > option').removeAttr('selected').filter("[value='"+task.valueForKey('project').valueForKey('uid')+"']").attr('selected', 'selected');
	editArea.find('.task-options div#proj-picker > select').unbind('change').bind('change', function(e) {
		NSLog('is this working?');
		UI.selectTools.updateHtmlSelect(this); //Becouse this removes the previous change action
		
		//fire off all updates
		//notesArea.blur(); //potentially 'BAD' call, this is un-needed for this edit anyway...
		titleField.blur();
		
		TaskListController.setProject_forTask_($(this).find('option:selected').attr('value'), $(this).closest('.guid').attr('id'));
	});
	
	editArea.find('.task-options div#status-picker > span.title').html(task.valueForKey('status'));
	editArea.find('.task-options div#status-picker > select > option').removeAttr('selected').filter("[value='"+task.valueForKey('status')+"']").attr('selected', 'selected');
	editArea.find('.task-options div#status-picker > select').die('change').live('change.statuspicker', function(e) {
		UI.selectTools.updateHtmlSelect(this); //Becouse this removes the previous change action
		GetTask($(this).closest('.guid').attr('id')).setValueForKey($(this).find('option:selected').attr('value'), 'status');	
	});
	
	if(task.valueForKey('completed')) {
		editArea.find('input.checkmark').attr('checked', 'checked');
	}
	//inline-alert-view
	
	//Add Various prompt views for incomming/unaccepted tasks.
	if(needsConnectionConfirmed) {
		//We need to add the connection acceptance to the inline-alert-view
		var connectionPromptViewInst = fClass.ConnectionPromptView.alloc().initWithTask(task);
		editArea.find('#inline-alert-view').append(connectionPromptViewInst.drawing().show()).show();
	} else if(task.valueForKey('incomming')) {
		var acceptTaskPromptViewInst = fClass.AssignmentPromptView.alloc().initWithTask(task);
		editArea.find('#inline-alert-view').append(acceptTaskPromptViewInst.drawing().show()).show();
	}
	
	if(!needsConnectionConfirmed) {
		TaskListController.taskDidBeginEditing_(guid);
	}
	
	//Update our edit button that we should be editing.
	if(window.taskEditButton) {
		window.taskEditButton.setState(true);
	}
}

//Used to update date field when an edit occurs from the date picker widget.
function updateEditorDateField(task) {
	var editArea = $('.task-edit');
		
	//Date
	var duedateArea = editArea.find('#optdate');
	var duedate = task.valueForKey('dueDate');
	NSLog('date:'+duedate);
	if(duedate) {
		var jsdate = Date.parse(duedate.description());
		
		if(jsdate.isToday()) {
			//Check if its has a time for today, or its due anyime today
			if(jsdate.getHours() > 0 && jsdate.getMinutes() > 0) {
				duedateArea.empty().text(jsdate.toString('h:mm tt'));
			} else {
				duedateArea.empty().text('Today');
			}
		} else {
			duedateArea.empty().text(jsdate.toString('MMM dd')+ ' at '+jsdate.toString('h:mm tt'));
		}
	}
}

//Note this must comment all editing in the edit area
function endEditTask() {
	if(DWiki.Editor && DWiki.Editor.seed) {
		/* DWiki.Editor is assumed to be sharing. It may not be however... */
		try {
			mobwrite.unshare(DWiki.Editor);
			DWiki.Editor.seed = null;
		} catch(err) {
		
		}
	}
	
	//Insure all edits are commited
	window.Context.scrollEventNotification();
	
	$('.task-edit .title').blur();
	$('.task-edit #opturl').blur();
	
	var guid = $('.task-edit').attr('id');
	var taskRow = null;
	if(guid) {
		var taskRow = $("div.task-row[id='"+guid+"']");
		//Handle if it was a pending task for creation
		if(taskRow.attr('state') && taskRow.attr('state') == 'pending') {
			if($('.task-edit .title').html().length < 3) {
				NSLog('delete the task, as the user never entered a title');
				TaskListController.deletePendingAction_("");
				return;
			} else {
				taskRow.attr('state', 'normal');
			}
		}
	} else {
		taskRow = $("div.task-row");
	}
	
	//Force update the task's notes if editing.
	
	if(DWiki.Editor && DWiki.Editor.editing) {
		TaskListController.taskDidEndNoteEditing_notes_(guid, DWiki.Editor.wikiText());
	}
	
	//$('.task-edit #wiki-notes').blur();
	
	$('.task-edit').hide().remove();
	taskRow.show();
	
	if(guid) {
		TaskListController.taskDidEndEditing_(guid);
	}
	
	if(window.taskEditButton) {
		window.taskEditButton.setState(false);
	}
}

/***************************************
	Callable from cocoa side or js side, these essentually
	expose various FrothJS methods to the cocoa side
****************************************/

/*
	Updates the ui with new task changes
*/
function refreshTask(guid) { //DEPRECIATED
	var task = GetTaskProxy(guid);
	var row = $('.task-row#'+guid);
	
	//Update backing simple row
	updateTaskRow_(task, row);
}

function extern_refreshTaskRowWithProxy(proxy) {
	ProjectsController.refreshTaskView(JSON.parse(proxy));
}

function selectTask(guid) {
	//NSLog('selected task:'+guid);
	$("div.task-row").removeClass('selected');
	if(guid) {
		$("div#"+guid+".task-row").addClass("selected");
		scrollTaskToVisible(guid);
	}
}

function scrollTaskToVisible(guid) {
	var row = $("div#"+guid+".task-row");
	
	
	//Insure that the task row is fully visible if possible, nudging up or down as needed.
	var scrollView = row.closest('.scroll-view');
	
	window.console.log('offset-top:'+row.position().top+" hieght:"+row.height()); //editArea.closest('.scroll-view');
	window.console.log('scrollview-top:'+scrollView.offset().top+" hiegth:"+scrollView.height());
	
	//Up
	if(row.offset().top < 24) {
		scrollView.animate({scrollTop: row.position().top }, 100);
	}
	
	//Down
	if(row.offset().top + row.height() > scrollView.height() + 4) {
		scrollView.animate({scrollTop: (row.position().top-scrollView.height()+row.height()+8)}, 100);
	}
	
	/*if(row.offset().top+row.height() > scrollView.height()-2) {	//Scroll From Below
		row.closest('.scroll-view').animate({scrollTop:(scrollView.height()-row.height())+scrollView.scrollTop()}, 10);
	}*/
	
}

function selectLabel(labelName) {
	labelName = labelName.replace('#', '');
	$('span.label').removeClass('selected');
	$("span#"+labelName+".label").addClass('selected');
}

function selectPriority(priority) {
	priority = priority.replace('!', '');
	$('span.priority').removeClass('selected');
	$("span#pr"+priority+".priority").addClass('selected');
}

/*
	Main call from cocoa, this should clear the list and re populate with task data assigned to
	..//arrangedObjects from controller.
	
	This clears the task list and relayouts it.
*/
var ProjectsController = null;
function LayoutList(projectsArray, tasksJSONString) {

	//This is depreciated... just return
	return;

	//Defined in app.tabs.project.js
	if(!ProjectsController) {
		ProjectsController = fClass.ProjectsTabController.alloc().init();
		$('#flip-view-container').append(ProjectsController.view.drawing().show());
	}
	
	//Allows for debug mode
	if(window.TaskListController) {
		//Passed as json.
		tasksArray = JSON.parse(tasksJSONString);
		
		ProjectsController.setProjects(projectsArray);
		ProjectsController.setTasks(tasksArray);
	}
}

function LayoutTasks(tasksJSONString) {
	if(!ProjectsController) {
		ProjectsController = fClass.ProjectsTabController.alloc().init();
		$('#flip-view-container').append(ProjectsController.view.drawing().show());;
	}
	//NSLog("tasksJSONString:"+tasksJSONString);
	//tasksArray = JSON.parse(tasksJSONString);
	tasksArray = eval(tasksJSONString);
	ProjectsController.setTasks(tasksArray);
}

function LayoutTasksNoJSON(tasksArray) {
	if(!ProjectsController) {
		ProjectsController = fClass.ProjectsTabController.alloc().init();
		$('#flip-view-container').append(ProjectsController.view.drawing().show());;
	}
	//NSLog("tasksJSONString:"+tasksJSONString);
	//tasksArray = JSON.parse(tasksJSONString);
	ProjectsController.setTasks(tasksArray);
}

function LayoutProjectTabs(projectsArray) {
	if(ProjectsController) {
		ProjectsController.setProjects(projectsArray);
	}
}

/*** Display Helpers ***/

/*
	Reads out all #Labels and also any !3 (stars) !9 !1 !0 !3 !4
	returns html generated title
*/
function parsedTaskTitle(title) {
	//Parse label
	var lbs = title.match(/#[a-zA-Z0-9]+/g);
	var parsedTitle = title;
	for(i in lbs) {
		var lbl = lbs[i].replace('#', '');
		
		//Add the formating for labels
		parsedTitle = parsedTitle.replace(lbs[i], "<span class='label' id='"+lbl+"'>"+lbl+"</span>");

	}
	
	//Parse priority (only first one in task allowed)
	var stars = title.match(/![1-9]/g);
	for(i in stars) {
		var star = stars[i].replace('!', '');
		parsedTitle = parsedTitle.replace(stars[i], "<span class='priority' id='pr"+star+"'><span>&#x2605;</span>"+star+"</span>");
		break;
	}
	
	parsedTitle = ProcessDejumbleLinks(parsedTitle);
	
	return parsedTitle;
}

/*** Cocoa Helpers ***/

function arrayKeysCanChangeRowSelection() {
	if($('.dwiki.focused').length > 0) {
		return false;
	}
	return true;
}

function setPriorityForTask(priority, uid) {
	var task = GetTask(uid);
	var title = task.valueForKey('title');
	if(priority == 0) {
		title = title.replace(/(![1-9])/g, '');
	} else {
		if(title.match(/(![1-9])/g)) {
			title = title.replace(/(![1-9])/g, '!'+priority);
		} else {
			title = title + ' !'+ priority;
		}
	}
	TaskListController.taskDidEndTitleEditing_title_(uid, title)
}

/*
	Only parses and labels in string. Not or joined labels.
*/
function parseAndLabelsInString(str) {
	if(str.search(' or ') == -1) {
		var arr = str.match(/#[a-zA-Z0-9]+/g);
		if(arr.length < 0) {
			return '';
		}
		return arr.join(' ');
	}
	return '';
}

function ShowShareWidgetAttachedToRow(guid) {
	var row = $("div#"+guid+".task-row");
	TaskListController.showShareWidgetForTaskIdenifier_top_left_(
		guid, 
		$(document).height()-row.offset().top-(row.height())+10,
		row.offset().left+36-22);
}